part of katana_module;

@immutable
abstract class RerouteConfig {
  const RerouteConfig();
  Map<String, bool Function(BuildContext context)> get value;
}

class LoginRequiredRerouteConfig extends RerouteConfig {
  const LoginRequiredRerouteConfig({
    this.routePath = "/landing",
  });

  final String routePath;

  @override
  Map<String, bool Function(BuildContext context)> get value => {
        routePath: (context) {
          return context.model?.isSignedIn ?? true;
        },
      };
}

class UserDocumentQueryRerouteConfig extends RerouteConfig {
  const UserDocumentQueryRerouteConfig({
    this.routePath = "/landing",
    this.queryPath = "user",
  });

  final String queryPath;
  final String routePath;

  @override
  Map<String, bool Function(BuildContext context)> get value => {
        routePath: (context) {
          final provider = context.model?.documentProvider(queryPath);
          if (provider == null) {
            return false;
          }
          final doc = readProvider(provider);

          return context.model?.isSignedIn ?? true;
        },
      };
}
